/*
 * bmp.c
 *
 *  Created on: 2009/01/20
 *      Author: tmk
 */
#include	<pspiofilemgr.h>
#include	<stdlib.h>

#include	"bmp.h"

#define RGB5551(r,g,b) ((((b>>3) & 0x1F)<<10)|(((g>>3) & 0x1F)<<5)|(((r>>3) & 0x1F)<<0)|0x8000)


static int bitToPalCount(int bitCount);

void bmpPalTo5551(unsigned short *cols, PRGBQUAD pallet, int count) {
	int i;
	for(i = 0; (i < count); i++) {
		cols[i] = RGB5551(pallet[i].rgbRed, pallet[i].rgbGreen, pallet[i].rgbBlue );
	}
}

// bmpC[Wɕϊ
unsigned char *bmpToImg(char *bmp, PBITMAPINFOHEADER header) {
	int bmp_inc;
	int bmp_y_inc;
	int perPixel;
	if (header->biBitCount == 2) {
		// TODO 
	} else if (header->biBitCount == 4) {
		// TODO 
	} else if (header->biBitCount == 8) {
		bmp_inc = 1;
		bmp_y_inc = (header->biWidth % 4)?(4 - (header->biWidth % 4)):0; // Ps͂SoCgE
		perPixel = 1;
	} else {
		// TODO 
	}

	int size = (header->biWidth * header->biHeight) * perPixel;
	unsigned char *buf = malloc(size);
	unsigned char *bmp_ptr = bmp;
	int x, y;
	for(y = 0; (y < header->biHeight); y++) {
		unsigned char *ptr = &buf[(header->biHeight - 1 - y) * header->biWidth];
		for(x = 0; (x < header->biWidth); x++) {
			*ptr = *bmp_ptr;
			bmp_ptr+=bmp_inc;
			ptr ++;
		}
		bmp_ptr+=bmp_y_inc;
	}

	return(buf);
}

// bmp5551̃C[Wɕϊ
unsigned short *bmpTo5551(char *bmp, PBITMAPINFOHEADER header, PRGBQUAD pallet) {
	unsigned short cols[256];

	int palCount = bitToPalCount(header->biBitCount);
	if ((palCount > 0) && pallet) {
		bmpPalTo5551(*cols, pallet, palCount);
	}

	int bmp_inc;
	int bmp_y_inc;
	if (header->biBitCount == 2) {
		// TODO 
	} else if (header->biBitCount == 4) {
		// TODO 
	} else if (header->biBitCount == 8) {
		bmp_inc = 1;
		bmp_y_inc = (header->biWidth % 4)?(4 - (header->biWidth % 4)):0; // Ps͂SoCgE
	} else if (header->biBitCount == 24) {
		bmp_inc = 3;
		bmp_y_inc = ((header->biWidth * 3) % 4)?(4 - ((header->biWidth * 3) % 4)):0; // Ps͂SoCgE
	} else if (header->biBitCount == 32) {
		bmp_inc = 4;
		bmp_y_inc = 0;
	} else {
		// TODO 
	}

	int size = (header->biWidth * header->biHeight) * 2;
	unsigned short *buf = malloc(size);
	unsigned char *bmp_ptr = bmp;
	int x, y;
	for(y = 0; (y < header->biHeight); y++) {
		unsigned short *ptr = &buf[(header->biHeight - 1 - y) * header->biWidth];
		for(x = 0; (x < header->biWidth); x++) {
			unsigned short col;
			if (header->biBitCount == 2) {
				// TODO 
			} else if (header->biBitCount == 4) {
				// TODO 
			} else if (header->biBitCount == 8) {
				col = cols[*bmp_ptr];
				bmp_ptr+=bmp_inc;
			} else if (header->biBitCount == 24) {
				col = RGB5551(bmp_ptr[2], bmp_ptr[1], bmp_ptr[0]); // B,G,R
				bmp_ptr+=bmp_inc;
			} else if (header->biBitCount == 32) {
				col = RGB5551(bmp_ptr[2], bmp_ptr[1], bmp_ptr[0]); // B,G,R,rv
				bmp_ptr+=bmp_inc;
			} else {
				// TODO 
			}
			*ptr = col;
			ptr ++;
		}
		bmp_ptr+=bmp_y_inc;
	}

	return(buf);
}

char *loadBmp(char *file, PBITMAPINFOHEADER header, PRGBQUAD pallet) {

	int fin;

	BITMAPFILEHEADER fileHeader;

	fin = sceIoOpen( file, PSP_O_RDONLY, 0777 );
	if ( fin < 0 ) {
		return 0x00;
	}

	int readsize = sceIoRead( fin, &fileHeader, sizeof(BITMAPFILEHEADER));
	if (readsize != sizeof(BITMAPFILEHEADER)) {
		sceIoClose( fin );
		return 0x00;
	}

	if (memcmp("BM", &fileHeader, 2)) { // BMPȊO
		sceIoClose( fin );
		return 0x00;
	}

	BITMAPINFOHEADER wHeader;
	PBITMAPINFOHEADER hPtr = &wHeader;
	if (header != 0x00) {
		hPtr = header;
	}
	readsize = sceIoRead( fin, hPtr, sizeof(BITMAPINFOHEADER));
	if (readsize != sizeof(BITMAPINFOHEADER)) {
		sceIoClose( fin );
		return 0x00;
	}

	if (hPtr->biSize != 40) { // WINȊO
		sceIoClose( fin );
		return 0x00;
	}

	if (hPtr->biCompression != 0) { // k͔Ή
		sceIoClose( fin );
		return 0x00;
	}

	int palCount = bitToPalCount(hPtr->biBitCount);
	if (palCount != 0) {
		RGBQUAD wpalHeader[palCount];
		RGBQUAD *palPtr = wpalHeader;
		if (pallet != 0x00) {
			palPtr = pallet;
		}

		readsize = sceIoRead( fin, palPtr, sizeof(RGBQUAD) * palCount);
		if (readsize != (sizeof(RGBQUAD) * palCount)) {
			sceIoClose( fin );
			return 0x00;
		}
	}

	char *bmpPtr = malloc(hPtr->biSizeImage);
	readsize = sceIoRead( fin, bmpPtr, hPtr->biSizeImage);
	if (readsize != hPtr->biSizeImage) {
		sceIoClose( fin );
		free(bmpPtr);
		return 0x00;
	}

	return bmpPtr;
}

static int bitToPalCount(int bitCount) {
	int palCount;
	if (bitCount == 1) {
		palCount = 2;
	} else if (bitCount == 4) {
		palCount = 16;
	} else if (bitCount == 8) {
		palCount = 256;
	} else {
		palCount = 0;
	}
	return palCount;
}
