#include <pspiofilemgr.h>
#include <pspctrl.h>
#include <stdio.h>
#include <string.h>
#include "main.h"

void menu_frame(const char *msg0, const char *msg1);

extern u32 new_pad;

int PlayMDX(char *mdxname);
void StopMDX(void);
int getPlayEnd();
void getPlayStatus(char *ptr);
int getMdxTitle(char *mdxTitle, char *mdxfilename);
void getTitles(char *path, int count);

SceIoDirent files[MAX_ENTRY];
SceIoDirent *sortfiles[MAX_ENTRY];
volatile char mdxTitle[MAX_ENTRY][256];

////////////////////////////////////////////////////////////////////////
// NCbN\[g

void SJISCopy(SceIoDirent *a, unsigned char *file)
{
	unsigned char ca;
	int i;
	int len = strlen(a->d_name);

	for(i=0;i<=len;i++){
		ca = a->d_name[i];
		if (((0x81 <= ca)&&(ca <= 0x9f))
		|| ((0xe0 <= ca)&&(ca <= 0xef))){
			file[i++] = ca;
			file[i] = a->d_name[i];
		}
		else{
			if(ca>='a' && ca<='z') ca-=0x20;
			file[i] = ca;
		}
	}

}
int cmpFile(SceIoDirent *a, SceIoDirent *b)
{
    unsigned char file1[0x108];
    unsigned char file2[0x108];
	unsigned char ca, cb;
	int i, n, ret;

	if(a->d_stat.st_attr==b->d_stat.st_attr){
		SJISCopy(a, file1);
		SJISCopy(b, file2);
		n=strlen((char*)file1);
		for(i=0; i<=n; i++){
			ca=file1[i]; cb=file2[i];
			ret = ca-cb;
			if(ret!=0) return ret;
		}
		return 0;
	}

	if(a->d_stat.st_attr & FIO_SO_IFDIR) return -1;
	else					return 1;
}

void sort(SceIoDirent **a, int left, int right) {
	SceIoDirent *tmp, *pivot;
	int i, p;

	if (left < right) {
		pivot = a[left];
		p = left;
		for (i=left+1; i<=right; i++) {
			if (cmpFile(a[i],pivot)<0){
				p=p+1;
				tmp=a[p];
				a[p]=a[i];
				a[i]=tmp;
			}
		}
		a[left] = a[p];
		a[p] = pivot;
		sort(a, left, p-1);
		sort(a, p+1, right);
	}
}

int getExtId(const char *szFilePath, LPEXTENTIONS pExt) {
	char *pszExt;
	int i;
	if((pszExt = strrchr(szFilePath, '.'))) {
		pszExt++;
		for (i = 0; pExt[i].szExt; i++) {
			if (!stricmp(pExt[i].szExt,pszExt)) {
				break;
			}
		}
		return pExt[i].nExtId;
	}
	return EXT_UNKNOWN;
}



int getDir(const char *path, LPEXTENTIONS pExt) {
	int fd, b=0;

	int nfiles = 0;

	// ^Cg擾()
	getTitles(0x00, 0);

	if(strcmp(path, "ms0:/")){
		strcpy(files[nfiles].d_name, "..");
		files[nfiles].d_stat.st_attr = FIO_SO_IFDIR;
		sortfiles[nfiles] = files + nfiles;
		nfiles++;
		b=1;
	}

	fd = sceIoDopen(path);
	while(nfiles<MAX_ENTRY) {
		memset(&files[nfiles], 0x00, sizeof(SceIoDirent));
		mdxTitle[nfiles][0] = 0x00;

		if(sceIoDread(fd, &files[nfiles])<=0) break;
		if(files[nfiles].d_name[0] == '.') continue;
		if(files[nfiles].d_stat.st_attr == FIO_SO_IFDIR){
			strcat(files[nfiles].d_name, "/");
			sortfiles[nfiles] = files + nfiles;
			nfiles++;
			continue;
		}
		sortfiles[nfiles] = files + nfiles;
		if (pExt) {
			if(getExtId(files[nfiles].d_name, pExt) != EXT_UNKNOWN) nfiles++;
		}
		else {
			nfiles++;
		}
	}
	sceIoDclose(fd);
	if(b)
		sort(sortfiles+1, 0, nfiles-2);
	else
		sort(sortfiles, 0, nfiles-1);

	// ^Cg擾
	getTitles(path, nfiles);

	return nfiles;
}

char FilerMsg[256];
int getFilePath(char *pszStartPath, LPEXTENTIONS pExt, char *pszSelFile, int nOldSel)
{
	unsigned long color;
	int top, rows=21, x, y, h, i, bMsg=0, up=0;
	char path[MAXPATH], oldDir[MAXNAME], *p;
	int sel = nOldSel;
	int nfiles;
	char out[MAXPATH];
	char title[256];
	int nextPlay = -1;
	int isPlay = 0;
	int isFadeout = 0;
	int isRepet = 0;

	top = sel-3;

	strcpy(path, pszStartPath);
	if(FilerMsg[0])
		bMsg=1;

	nfiles = getDir(path, pExt);

	if (pszSelFile) {
		// vt@CT
		int nIndex;
		for (nIndex = 0; nIndex < nfiles; nIndex++) {
			if (!strcmp(sortfiles[nIndex]->d_name, pszSelFile)) {
				sel = nIndex;
				break;
			}
		}
	}

	for(;;){
		readpad();
		if(new_pad)
			bMsg=0;
		if((new_pad & PSP_CTRL_CIRCLE) || (nextPlay != -1)){
			if(sortfiles[sel]->d_stat.st_attr == FIO_SO_IFDIR) {
				if (nextPlay == -1) { // {^
					if(!strcmp(sortfiles[sel]->d_name, "..")){
						up = 1;
					}else{
						strcat(path,sortfiles[sel]->d_name);
						nfiles = getDir(path, pExt);
						sel = 0;
					}
				}
			}else{
				strcpy(out, path);
				strcat(out, sortfiles[sel]->d_name);
//				strcpy(pszStartPath,path);
				if (pszSelFile) strcpy(pszSelFile, sortfiles[sel]->d_name);
//				return sel;
				PlayMDX(out);
				isFadeout = 0;
				isPlay = 1;
			}
			nextPlay = -1;
		}else if(new_pad & PSP_CTRL_CROSS){
			if (MessageBox("Are you sure to EXIT to PSP menu ?", RGB(255, 0, 0), MB_OKCANCEL) == IDOK) {
				return -1;
			}
		}else if(new_pad & PSP_CTRL_TRIANGLE){
			up=1;
		}else if(new_pad & PSP_CTRL_AD_UP){
			sel--;
		}else if(new_pad & PSP_CTRL_AD_DOWN){
			sel++;
		}else if(new_pad & PSP_CTRL_AD_LEFT){
			sel-=10;
		}else if(new_pad & PSP_CTRL_AD_RIGHT){
			sel+=10;
		}else if(new_pad & PSP_CTRL_LTRIGGER){
			sel--;
			nextPlay = sel;
		}else if(new_pad & PSP_CTRL_RTRIGGER){
			sel++;
			nextPlay = sel;
		}

		if (!isRepet) {
			if (isPlay) {
				if (!isFadeout && getPlayEnd()) {
					isFadeout = 5 * 60;
				}

				if (isFadeout && (nextPlay == -1) && !up) {
					isFadeout --;
					psp_sound_add_volume(-100);
					if (isFadeout <= 0) {
						StopMDX();
						isPlay = 0;
						sel++;
						nextPlay = sel;
					}

				}
			}
		}

		if(up){
			if(strcmp(path,"ms0:/")){
				p=strrchr(path,'/');
				*p=0;
				p=strrchr(path,'/');
				p++;
				strcpy(oldDir,p);
				strcat(oldDir,"/");
				*p=0;
				nfiles = getDir(path, pExt);
				sel=0;
				for(i=0; i<nfiles; i++) {
					if(!strcmp(oldDir, sortfiles[i]->d_name)) {
						sel=i;
						top=sel-3;
						break;
					}
				}
			}
			up=0;
		}

		if(top > nfiles-rows)	top=nfiles-rows;
		if(top < 0)				top=0;
		if(sel >= nfiles)		sel=nfiles-1;
		if(sel < 0)				sel=0;
		if(sel >= top+rows)		top=sel-rows+1;
		if(sel < top)			top=sel;

		if (nextPlay != sel) {
			nextPlay = -1;
		}

		getPlayStatus(FilerMsg);

//		if(bMsg)
			menu_frame(FilerMsg,"FOK@~FCANCEL@FUP");
//		else
//			menu_frame(path,"FOK@~FCANCEL@FUP");

		// XN[o[
		if(nfiles > rows){
			h = 219;
			pgDrawFrame(445,25,446,248,DEF_COLOR1);
			pgFillBox(448, h*top/nfiles + 27,
				460, h*(top+rows)/nfiles + 27,DEF_COLOR1);
		}

		x=28; y=32;
		for(i=0; i<rows; i++){
			if(top+i >= nfiles) break;
			if(top+i == sel) color = DEF_COLOR2;
			else			 color = DEF_COLOR3;
			mh_print(x, y, sortfiles[top+i]->d_name, color);
			if (mdxTitle[top+i][0] != 0x00) {
				sprintf(title, "%-68.68s", mdxTitle[top+i]);
				mh_print(x + (14 * 5), y, title, color);
			}
			y+=10;
		}

		meter();

		pgScreenFlipV();
	}
}

extern u16 meterCol[][256];
extern u8 *meterImg;
void meter() {

	if (meterImg == 0x00) {
		return;
	}

	int i;

	pgFillBox(317, 168,
		317 + 127, 168 + (10 * 8) - 1, DEF_COLOR0);

	for(i = 0; i < 8; i++) {
		updateLevelMeter(i);
//		int x = 28, y = 32 + (i * 18);
		int x = 317, y = 168 + (i * 10);
		pgBitBlt256(x, y, 128, 8, 1, meterImg, meterCol[i]);
	}

}

void menu_frame(const char *msg0, const char *msg1)
{
//	char msg[32];
//	int color;
//	if(g_bEnableBitmap)
//		pgBitBlt(0,0,480,272,1,g_bgBitmap);
//	else
		pgFillvram(DEF_COLOR0);
	mh_print(314, 1, "  mdxplayer for PSP Ver.0.01 ", DEF_COLOR1);
//	GetBatteryInfoString(msg, &color);
//	mh_print(464-(_strlen(msg)*5), 254, msg, color);
	// bZ[WȂ
	if(msg0!=0) mh_print(17, 12, msg0, DEF_COLOR2);
	pgDrawFrame(17,23,463,250,DEF_COLOR1);
	pgDrawFrame(18,24,462,249,DEF_COLOR1);
	// 
	if(msg1!=0) mh_print(17, 254, msg1, DEF_COLOR2);
}

u32 MessageBox(char*pszMsg, u32 color, u32 ulTypes)
{
	int cbI;
	int nMsgLen, nBtnLen;
	unsigned int ulEnableBtn;
	unsigned char bKeyReleased = 0;
	typedef struct {
		unsigned int ulType;
		char *pszBtnMsg;
		unsigned int ulEnableBtn;
	}MSGTYPE;
	MSGTYPE stMsgType[] = {
		{MB_OK, "FOK", IDOK},
		{MB_OKCANCEL, "FOK  ~FCancel", IDOK | IDCANCEL},
		{MB_YESNO, "FYES  ~FNO", IDYES | IDNO}
	};

	for (cbI = 0; cbI < (sizeof(stMsgType) /sizeof(MSGTYPE)); cbI++) {
		if (stMsgType[cbI].ulType == ulTypes) {
			ulEnableBtn = stMsgType[cbI].ulEnableBtn;
			break;
		}
	}
	if (cbI == (sizeof(stMsgType) /sizeof(MSGTYPE))) {
		return 0x00000000;
	}

	nMsgLen = strlen(pszMsg);
	nBtnLen = strlen(stMsgType[cbI].pszBtnMsg);
	// msg
	pgDrawFrame( 240-nMsgLen*5/2-30-1, 110-1, 240+nMsgLen*5/2+30+1, 167+1, RGB(64,64,64));
	pgDrawFrame( 240-nMsgLen*5/2-30-1, 110-1, 240+nMsgLen*5/2+30, 167, RGB(212,208,200));
	pgFillBox( 240-nMsgLen*5/2-30, 110, 240+nMsgLen*5/2+30, 167, RGB(0, 0, 0));
	mh_print(240-nMsgLen*5/2, 125, pszMsg, color);
	mh_print(240-nBtnLen*5/2, 145, stMsgType[cbI].pszBtnMsg, RGB(208, 208, 208));
	pgScreenFlipV();

	for(;;){
		readpad();
		if (!bKeyReleased) {
			pgWaitVn(1);
			if (now_pad & (PSP_CTRL_CIRCLE | PSP_CTRL_CROSS)) {
				continue;
			}
			else {
				bKeyReleased = 1;
			}
		}
		if(new_pad & PSP_CTRL_CIRCLE){
			if (ulEnableBtn & IDOK) return IDOK;
		}
		if(new_pad & PSP_CTRL_CROSS){
			if (ulEnableBtn & IDCANCEL) return IDCANCEL;
		}
		pgWaitVn(1);
	}
}

void ExtractPath(char *src) {
	int n;
	for (n = strlen(src); ((n > 0) && (src[n - 1] != '/')); --n)
		src[n - 1] = 0;
}
