/*
   AudioLib Sample

   Demonstrates how to get sound working with minimal effort.

   Based on sdktest sample from pspsdk
*/

#include <pspkernel.h>
#include <psppower.h>
#include <pspdebug.h>
#include <pspaudiolib.h>
#include <pspaudio.h>
#include <pspdisplay.h>
#include <pspctrl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>

#include "filer.h"

#include "bmp.h"

#include "depend.h"

#include "psp_sound.h"

#define __MXDRV_LOADMODULE
//#include "mxdrv.h"
//#include "x68sound.h"
#define	X68SNDERR_PCMOUT	(-1)
#define	X68SNDERR_TIMER		(-2)
#define	X68SNDERR_MEMORY	(-3)
#define X68SNDERR_NOTACTIVE	(-4)
#define	X68SNDERR_ALREADYACTIVE	(-5)
#define	X68SNDERR_BADARG	(-6)

#define X68SNDERR_DLL		(-1)
#define X68SNDERR_FUNC		(-2)

#define N_LOOP 2

#define min(x,y) ((x<y)?x:y)

u32 mxwin_MXDRV_GetPlayTime(void);
u32 mxwin_MXDRV_GetPlayNowTime(void);
u16 mxwin_MXDRV_GetL001e06(void);
u8 mxwin_MXDRV_GetL001e13(void);
u16 mxwin_MXDRV_GetFREQUENCY(int ch);
u8 mxwin_MXDRV_GetSTAT_FLAG_A_0016(int ch);
u8 mxwin_MXDRV_GetMXVAL_VOLUME(int ch);

/*
   This part of the code is more or less identical to the sdktest sample
*/

/* Define the module info section */
PSP_MODULE_INFO("mdxplayer", 0, 1, 1);
/* Define the main thread's attribute value (optional) */
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);
/* Define printf, just to make typing easier */
#define printf	pspDebugScreenPrintf

// ̃R[h W[Ɋ܂܂֐̑O錾:
int PlayMDX(TCHAR *mdxname);

extern TCHAR MDXTitle[];
TCHAR EXEFileName[FILENAME_MAX];
TCHAR INIFileName[FILENAME_MAX];

DWORD PlayTime = 0;
DWORD NowTime = 0;

DWORD WaveBufSize = 1024;
#define WaveBufBlk 4
BYTE *WaveBuf;
volatile int WaveoutWriteBlk = 0;
volatile int WaveoutPlayBlk =0;

//int WaveoutSamprate = 44100;
int WaveoutSamprate = 22050;

void *WaveoutHeader[WaveBufBlk];
int FillingWaveBuf;
int WaitPlayEnd = 0;

const EXTENTIONS stExtMdx[] = {
 {"mdx", EXT_MDX},
// {"zip", EXT_ZIP},
 {NULL,  EXT_UNKNOWN}
};
char RomPath[FILENAME_MAX+1];
char currentPath[FILENAME_MAX+1];


// mdxplayer
#define MXDRV_CALL05_STOP				0x05	/*MuCTRL_05_STOP*/
#define MXDRV_CALL06_PAUSE				0x06	/*MuCTRL_06_PAUSE*/
#define MXDRV_CALL07_CONTINUE			0x07	/*MuCTRL_07_CONT*/
#define MXDRV_CALL0C_FADEOUT			0x0c	/*MuCTRL_0C_FADEOUT*/
#define MXDRV_CALL0F_RESUME_PLAY		0x0f	/*MuCTRL_0F_RESUME_PLAY*/

volatile int psp_loop;
volatile int psp_sleep;


/* Exit callback */
static int exitCallback(int arg1, int arg2, void *common) {

	psp_loop = 0;
	psp_sleep = 0;

	scePowerSetClockFrequency(222, 222, 111);

	sceKernelExitGame();
	return 0;
}

// PowerCallback
static int powerCallback(int unknown, int pwrflags, void *arg)
{
	if (pwrflags & PSP_POWER_CB_POWER_SWITCH) {
		psp_sleep = 1;
	} else if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE) {
		psp_sleep = 0;
	}

	int cbid = sceKernelCreateCallback("Power Callback", ( int (*)(int, int, void*) )powerCallback, NULL);
	scePowerRegisterCallback(0, cbid);

	return 0;
}

/* Callback thread */
static int callbackThread(SceSize args, void *argp) {
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", (void*) exitCallback, NULL);
	sceKernelRegisterExitCallback(cbid);

	cbid = sceKernelCreateCallback("Power Callback", (void*) powerCallback, NULL);
	scePowerRegisterCallback(0, cbid);

	sceKernelSleepThreadCB();

	return 0;
}

/* Sets up the callback thread and returns its thread id */
static int setupCallbacks(void) {
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", callbackThread, 0x12, 0xFA0, 0, 0);
	if (thid >= 0) {
		sceKernelStartThread(thid, 0, 0);
	}
	return thid;
}

static void ns86_sound_update(int p)
{
	s16 *buffer = (s16 *)p;

	X68000_Update_stream( (s16 *)p, PSP_SOUND_SAMPLES);
}

// ^Cg擾Xbh
extern SceIoDirent *sortfiles[];
extern volatile char mdxTitle[MAX_ENTRY][256];

char *getTitlePath[MAXPATH];
int getTitleCount = 0;
void getTitles(char *path, int count) {

	getTitleCount = count;

	termGetTitleThread();
	if (path != 0x00) {
		strcpy(getTitlePath, path);
		setupGetTitleThread();
	}
}

volatile int getTitleThreadTerm = 0;
int getTitleThread (SceSize args, void *argp) {
char out[MAXPATH];

	while (getTitleThreadTerm == 0) {
		int sel = 0;
		while ((sel < getTitleCount)
				&& (getTitleThreadTerm == 0)
				&& (sortfiles[sel]->d_name[0] != 0x00)) {
			if(sortfiles[sel]->d_stat.st_attr != FIO_SO_IFDIR) {
				strcpy(out, getTitlePath);
				strcat(out, sortfiles[sel]->d_name);

				getMdxTitle(mdxTitle[sel], out);
			}
			sel++;
			sceKernelDelayThread(500000); // 0.5sec
		}
		break;
	}

	sceKernelSleepThread();
//	sceKernelExitThread(0);

	return (0);
}

int getTitleThreadHandle = -1;
int setupGetTitleThread(void) {

	getTitleThreadTerm = 0;

	getTitleThreadHandle = sceKernelCreateThread("getTitle_thread", getTitleThread, 0x22, 0xFA0, 0, 0);
	if (getTitleThreadHandle >= 0) {
		sceKernelStartThread(getTitleThreadHandle, 0, 0);
	}
	return getTitleThreadHandle;
}

void termGetTitleThread(void) {

	getTitleThreadTerm = 1;

	if (getTitleThreadHandle != -1) {
		sceKernelDeleteThread(getTitleThreadHandle);
		getTitleThreadHandle = -1;
	}
}

int main(int argc, char *argp[]) {

	psp_loop = 1;
	psp_sleep = 0;

	strncpy(currentPath, argp[0], sizeof(currentPath));
	currentPath[sizeof(currentPath) - 1] = 0;
	ExtractPath(currentPath);

	memset(mdxTitle, 0x00, sizeof(mdxTitle));

	pspDebugScreenInit();
//	pspDebugScreenInitEx(NULL, PSP_DISPLAY_PIXEL_FORMAT_5551, 1);

	setupCallbacks();

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);

	pspDebugScreenSetXY(0,0);

    printf("mxwin_MXDRV_init ...\n");

	mxwin_MXDRV_init(44100);

	initLastStatus();
	getLevelMeter();

//	scePowerSetClockFrequency(333, 333, 222);

    printf("start mdxplayer ...\n");
/*
	while(1) {
		SceCtrlData paddata;
		sceCtrlPeekBufferPositive(&paddata, 1);
		if (paddata.Buttons & PSP_CTRL_CIRCLE) {
			break;
		}
		sceDisplayWaitVblankStart();
	}
*/
	pgInit();
	pgScreenFrame(2, 0);

	psp_sound_init();

	psp_sound->stack	= 0x10000;				/* audio stack size[bytes] */
	psp_sound->stereo	= 1;					/* 0:monoral 1:stereo (This sample was stereo only) */
	psp_sound->callback = ns86_sound_update;	/* do audio callbacked function */

	psp_sound_start();
	psp_sound_enable(1);						/* psp_sound_enable(1) need after psp_sound_init() and psp_sound_start() */

	strcpy(RomPath, currentPath);
	strcat(RomPath, "mdx/");

	getFilePath(RomPath, (LPEXTENTIONS)&stExtMdx, NULL, 0);

	psp_loop = 0;

/*
	PlayMDX( "ms0:\\mdx\\test.mdx" );

    printf("PlayMDX after\n");

	int disp;
	static int nowtime_last = -1;
	int t, t2;

	while(1) {
		sceDisplayWaitVblankStart();

//		if ( WaveoutPlayBlk == WaveoutWriteBlk ) {
//		} else {
//			fillWave();
//		}

		NowTime = GetPlayTimeMDX();

		disp = FALSE;
		t = NowTime / 1000;
		if ( nowtime_last != t ) {
			nowtime_last = t;
			disp = TRUE;
		}
//		if ( disp ) {
			t2 = PlayTime / 1000;
			t = min( t, 99*60+59 );
			t2 = min( t2, 99*60+59 );

			pspDebugScreenSetXY(0,2);
//			printf("PLAY TIME: %02d:%02d / %02d:%02d", t/60, t%60, t2/60, t2%60 );
			printf("PLAY TIME: %02d:%02d / %02d:%02d %d %d", t/60, t%60, t2/60, t2%60, WaveoutPlayBlk, WaveoutWriteBlk);
//		}
	}

*/

	scePowerSetClockFrequency(222, 222, 111);

	psp_sound_enable(0);
	psp_sound_stop();
	mxwin_MXDRV_Call( MXDRV_CALL05_STOP );
	mxwin_MXDRV_exit();

	sceKernelExitGame();

	return 0;
}

int PlayMDX(TCHAR *mdxname) {
	mxwin_MXDRV_Call( MXDRV_CALL05_STOP );
	NowTime = 0;
	mxwin_PlayMDX( mdxname );
	psp_sound_set_volume();
	PlayTime = mxwin_MXDRV_GetPlayTime();
}

void StopMDX(void) {
	mxwin_MXDRV_Call( MXDRV_CALL05_STOP );
}

// x[^
#define W_LEVELMETERINFO 64
#define OFS_LEVELMETERPAL 32
u16 meterCol[8][256];
u8 *meterImg = 0x00;
u16 PALLevelMeter[W_LEVELMETERINFO * 2];

typedef struct tagLastStatus {
	BYTE NoteOnKey;
	BYTE NoteOnKeyCount;
	BYTE BendKey;
	BYTE S001b_back;
	BYTE Hit;
	int Volume;
	int Panpot;
	long Detune;
	int Voice;
	int Q;
	DWORD Ptr;
	long LFOPitch;
	int LFOPitch1;
	int LFOPitch2;
	int LFOPitch3;
	int LFOPitch4;
	long LFOVolume;
	int LFOVolume1;
	int LFOVolume2;
	int LFOVolume3;
	int LFOVolume4;
	char LevelMeter[W_LEVELMETERINFO];
	int LevelMeterInit;
	int LevelMeterPeak;
	int LevelMeterPeakLast;
	int LevelMeterPeakLate;
	int LevelMeterPeakDecCt;
	int LevelMeterNow;
	int LevelMeterNowLast;
} LASTSTATUS;
static LASTSTATUS LastStatus[16];

void getLevelMeter(void) {

char file[FILENAME_MAX+1];
BITMAPINFOHEADER header;
RGBQUAD pallet[256];
int i;

	strcpy(file, currentPath);
	strcat(file, "levelmeter.bmp");

	char *bmp = loadBmp(file, &header, pallet);

	if (bmp != 0x00) {
		bmpPalTo5551(meterCol, pallet, 256);
		for ( i=1; i < 8; i++ ) {
			memcpy(meterCol[i], meterCol, sizeof(u16) * 256);
		}
		meterImg = bmpToImg(bmp, &header);
		free(bmp);

		for ( i=0; i < W_LEVELMETERINFO * 2; i++ ) {
			PALLevelMeter[i]  = meterCol[0][i + OFS_LEVELMETERPAL];
		}
	}

}

void initLastStatus(
	void
) {
	int ch;

	for ( ch=0; ch<16; ch++ ) {
		LastStatus[ch].NoteOnKey = (BYTE)-1;
		LastStatus[ch].NoteOnKeyCount = 0;
		LastStatus[ch].BendKey = (BYTE)-1;
		LastStatus[ch].S001b_back = 0;
		LastStatus[ch].Hit = 0;
		LastStatus[ch].Volume = INT_MAX;
		LastStatus[ch].Panpot = INT_MAX;
		LastStatus[ch].Detune = LONG_MAX;
		LastStatus[ch].Voice = INT_MAX;
		LastStatus[ch].Q = INT_MAX;
		LastStatus[ch].Ptr = (DWORD)-1;
		LastStatus[ch].LFOPitch = LONG_MAX;
		LastStatus[ch].LFOPitch1 = INT_MAX;
		LastStatus[ch].LFOPitch2 = INT_MAX;
		LastStatus[ch].LFOPitch3 = INT_MAX;
		LastStatus[ch].LFOPitch4 = INT_MAX;
		LastStatus[ch].LFOVolume = LONG_MAX;
		LastStatus[ch].LFOVolume1 = INT_MAX;
		LastStatus[ch].LFOVolume2 = INT_MAX;
		LastStatus[ch].LFOVolume3 = INT_MAX;
		LastStatus[ch].LFOVolume4 = INT_MAX;
		ZeroMemory( &LastStatus[ch].LevelMeter[0], sizeof(LastStatus[ch].LevelMeter) );
		LastStatus[ch].LevelMeterInit = 1;
		LastStatus[ch].LevelMeterPeak = 0;
		LastStatus[ch].LevelMeterPeakLast = -1;
		LastStatus[ch].LevelMeterPeakLate = 0;
		LastStatus[ch].LevelMeterPeakDecCt = 0;
		LastStatus[ch].LevelMeterNow = 0;
		LastStatus[ch].LevelMeterNowLast = -1;
	}

}

int getMdxTitle(
	TCHAR *mdxTitle,
	TCHAR *mdxfilename
) {
	int fin;
	size_t fsize;
	int mdxsize;
	BYTE fptr[256];
	BYTE *p;
	BYTE c;

//#define PSP_ASYNC 1
	// MDXt@Cǂݍ
#ifdef PSP_ASYNC
	fin = sceIoOpenAsync( mdxfilename, PSP_O_RDONLY, 0777 );
	SceInt64 result;
	sceIoWaitAsync(fin, &result);
#else
	fin = sceIoOpen( mdxfilename, PSP_O_RDONLY, 0777 );
#endif
	if ( fin < 0 ) goto err_readmdx;
//	fsize = sceIoLseek32( fin, 0, SEEK_END );
//	sceIoLseek32( fin, 0, SEEK_SET );
//	fptr = (BYTE *)malloc( fsize );
//	if ( fptr == NULL ) {
//		goto err_readmdx;
//	}
#ifdef PSP_ASYNC
	sceIoReadAsync( fin, fptr, sizeof(fptr));
	sceIoWaitAsync(fin, &result);
	mdxsize = result;
#else
	mdxsize = sceIoRead( fin, fptr, sizeof(fptr));
#endif

#ifdef PSP_ASYNC
	sceIoCloseAsync( fin );
	sceIoWaitAsync(fin, &result);
#else
	sceIoClose( fin );
#endif

	// ^CgXLbv
	p = fptr;
	while ( mdxsize-- ) {
		c = *(p++);
		if ( c == 0x0d ) break;
		if ( c == 0x0a ) break;
		if ( c < 0x20 ) {
			if ( c != 0x1b ) goto err_brokenmdx;
		}
	}
	if ( mdxsize <= 0 ) goto err_brokenmdx;
	p--;
	*(p++) = 0x00;

	strcpy(mdxTitle, fptr);

	return (0);

	// LZXWJ
	// ݂̓T{EEE^^;B
	goto err_brokenmdx;

  err_readmdx:;
	return (1);

  err_brokenmdx:;
	return (2);

}

int getPlayEnd() {
	DWORD t = mxwin_MXDRV_GetPlayNowTime();
	if (t > PlayTime) {
		return 1;
	} else {
		return 0;
	}
}

void getPlayStatus(char *ptr) {
	int t, t2;

	NowTime = mxwin_MXDRV_GetPlayNowTime();
	t = NowTime / 1000;

	t2 = PlayTime / 1000;
	t = min( t, 99*60+59 );
	t2 = min( t2, 99*60+59 );

	sprintf(ptr, "%-74.74s: %02d:%02d / %02d:%02d", MDXTitle, t/60, t%60, t2/60, t2%60 );
}

void updateLevelMeter(int ch) {

	int i;

	int keyon;
//	MXWORK_CH *p;
	long sts;
	LASTSTATUS *l;
	int levelmeterput;
	int vol;

	static UBYTE VolTable[] = {
		0x2a,0x28,0x25,0x22,0x20,0x1d,0x1a,0x18,
		0x15,0x12,0x10,0x0d,0x0a,0x08,0x05,0x02,
	};

	l = &LastStatus[ch];

//	UINT16 mxwin_MXDRV_GetL001e06(void);		// Channel Mask
//	UINT8 mxwin_MXDRV_GetL001e13(void);			// End

	sts = (int)(BYTE)((mxwin_MXDRV_GetFREQUENCY(ch)+27)>>6);
	keyon = 0;
	if ( ( mxwin_MXDRV_GetSTAT_FLAG_A_0016(ch) & (1<<3) ) && (mxwin_MXDRV_GetL001e06() & (1<<ch)) && (!(mxwin_MXDRV_GetL001e13()!=0)) ) {
		if ( (l->NoteOnKey != sts) || (l->Hit) ) {
			l->NoteOnKey = (BYTE)sts;
			l->Hit = 0;
			keyon = 1;
		}
	} else {
		if ( l->NoteOnKey != (BYTE)-1 ) {
			l->NoteOnKey = (BYTE)-1;
		}
	}

	// Level Meter
	levelmeterput = 0;
	l->LevelMeterNowLast = l->LevelMeterNow;
	l->LevelMeterPeakLast = l->LevelMeterPeak;
	if ( l->LevelMeterNow ) {
		l->LevelMeterNow = (int)sqrtf(l->LevelMeterNow*l->LevelMeterNow*120.0/128);
	} else if ( l->LevelMeterNow < 0 ) {
		l->LevelMeterNow = 0;
	}
	if ( l->LevelMeterPeakLate >= 50 ) {
		l->LevelMeterPeak-=256;
		if ( l->LevelMeterPeakDecCt >= 4 ) {
			l->LevelMeterPeakDecCt = 0;
			l->LevelMeterPeak-=256;
		}
	} else {
		l->LevelMeterPeakLate++;
	}
	if ( l->LevelMeterPeak < 0 ) {
		l->LevelMeterPeak = 0;
	}
	if ( keyon ) {
		vol = mxwin_MXDRV_GetMXVAL_VOLUME(ch);
		if ( vol >= 128 ) {
			vol = 127 - (vol & 127);
		} else {
			vol = 127 - VolTable[vol];
		}
		l->LevelMeterNow = vol * 256;
		l->LevelMeterPeak = vol * 256;
		l->LevelMeterPeakLate = 0;
		l->LevelMeterPeakDecCt = 0;
	}
	if ( l->LevelMeterInit ) {
		l->LevelMeterInit = 0;
		levelmeterput = 1;
	}
	if ( l->LevelMeterPeak/2 != l->LevelMeterPeakLast/2 ) {
		levelmeterput = 1;
	}
	if ( l->LevelMeterNow/2 != l->LevelMeterNowLast/2 ) {
		levelmeterput = 1;
	}

	if ( levelmeterput ) {
		for ( i = 0; i <= (BYTE)(l->LevelMeterNow/256/2); i++ ) {
			l->LevelMeter[i] = 1;
		}
		for ( ; i < W_LEVELMETERINFO; i++ ) {
			l->LevelMeter[i] = 0;
		}
		l->LevelMeter[(BYTE)(l->LevelMeterPeak/256/2)] = 1;

		for ( i=0; i < W_LEVELMETERINFO; i++ ) {
			meterCol[ch][i + OFS_LEVELMETERPAL] = ( l->LevelMeter[i] ? PALLevelMeter[i] : PALLevelMeter[i + W_LEVELMETERINFO] );
		}
	}

}
