
#include "osd_driver.h"

#define USE_DEBUG_MESSAGE 1/*1*/
//#define USE_PSPAUDIOLIB 1/*1*/
#define USE_PSPAUDIOLIB 0/*1*/


#if (1==USE_DEBUG_MESSAGE)
	#include <pspdebug.h>
#endif /* (1==USE_DEBUG_MESSAGE) */

#if (1==USE_PSPAUDIOLIB)
	#include <pspaudiolib.h>
#endif /* (1==USE_PSPAUDIOLIB) */

#if 1
	#define MXDRV_CALL05_STOP				0x05	/*MuCTRL_05_STOP*/
	#define MXDRV_CALL06_PAUSE				0x06	/*MuCTRL_06_PAUSE*/
	#define MXDRV_CALL07_CONTINUE			0x07	/*MuCTRL_07_CONT*/
	#define MXDRV_CALL0C_FADEOUT			0x0c	/*MuCTRL_0C_FADEOUT*/
	#define MXDRV_CALL0F_RESUME_PLAY		0x0f	/*MuCTRL_0F_RESUME_PLAY*/

/*static*/extern /*int*/void mxwin_MXDRV_init(int bb_samprate);
#endif


//#define FILENAME_MAX 	255

static /*TCHAR*/INT8 mdxfilename[FILENAME_MAX+1];

//============================================================
//	PSP module info section
//============================================================

#ifdef KERNEL_MODE
PSP_MODULE_INFO("mdxplayer", 0x1000, 0, 4);
PSP_MAIN_THREAD_ATTR(0);
#else /* !defined(KERNEL_MODE) */
PSP_MODULE_INFO("mdxplayer", 0x0000, 0, 4);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER);

//PSP_MODULE_INFO("AUDIOLIBDEMO", 0x0000, 1, 1);
//PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

#endif /* (KERNEL_MODE) */


//============================================================
//	GLOBAL VARIABLES
//============================================================


volatile int psp_loop;
volatile int psp_sleep;



//============================================================
//	HOMEL[֘A
//============================================================

//============================================================
//	ExitCallback
//============================================================

static SceKernelCallbackFunction/*int*/ ExitCallback(int arg1, int arg2, void *arg)
{
	psp_loop = 0;
	psp_sleep = 0;
	sceKernelExitGame();
	return 0;
}


//============================================================
//	PowerCallback
//============================================================

static SceKernelCallbackFunction/*int*/ PowerCallback(int unknown, int pwrflags, void *arg)
{
	if (pwrflags & PSP_POWER_CB_POWER_SWITCH)
	{
		psp_sleep = 1;
	}
	else if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE)
	{
		psp_sleep = 0;
	}

	int cbid = sceKernelCreateCallback("Power Callback", ( int (*)(int, int, void*) )PowerCallback, NULL);
	scePowerRegisterCallback(0, cbid);
	return 0;
}


//============================================================
//	CreateCallbackThread
//============================================================
/*--------------------------------------------------------
	R[obNXbh쐬
--------------------------------------------------------*/

static int CallbackThread(SceSize/*int*/ args, void *argp)
{
	int cbid;
	cbid = sceKernelCreateCallback("Exit Callback", ( int (*)(int, int, void*) )ExitCallback, NULL);
	sceKernelRegisterExitCallback(cbid);

	cbid = sceKernelCreateCallback("Power Callback", ( int (*)(int, int, void*) )PowerCallback, NULL);
	scePowerRegisterCallback(0, cbid);

	sceKernelSleepThreadCB();
	return 0;
}

/*--------------------------------------------------------
	R[obNXbhݒ
--------------------------------------------------------*/

/* Sets up the callback thread and returns its thread id */
static /*int*/void SetupCallbacks(void)
{
	SceUID/*int*/ thread_id/* = 0*/;
	thread_id = sceKernelCreateThread("Update Thread", CallbackThread, /*0x11*/ 0x12, 0xFA0, 0, NULL);
	if (thread_id >= 0)
	{
		sceKernelStartThread(thread_id, 0, 0);
	}
//	return thread_id;
}



#if (1==USE_PSPAUDIOLIB)
/*
  Below this point is the interesting code in this sample
*/

//typedef struct
//{
//	INT16 left_audio;
//	INT16 right_audio;
//} psp_audio_sample_t;

/////////////////////////////

/* This function gets called by pspaudiolib every time the
   audio buffer needs to be filled. The sample format is
   16-bit, stereo. */
static void audioCallback(void* buf, unsigned int length, void *userdata)
{
	#if 0
	/*(܂Ȃ)*/
	INT16 mixing_buffer[PSP_SOUND_SAMPLES*2*2];
	X68000_Update_stream(mixing_buffer, length/*PSP_SOUND_SAMPLES*/ );
//	psp_audio_sample_t* ubuf = (psp_audio_sample_t*) buf;
	INT16* ubuf = (INT16*) buf;
	int i;
	for (i = 0; i < length; /*i++*/)
	{
//		INT16 samples_s16;
//		samples_s16 = ( (i<<4) );
		ubuf[i]/*ubuf[i].left_audio*/  = mixing_buffer[i]; /*samples_s16*/;i++;
//		ubuf[i]/*ubuf[i].right_audio*/ = mixing_buffer[i]; /*samples_s16*/;i++;
	}
	#else
	X68000_Update_stream( (INT16*)buf, length/*PSP_SOUND_SAMPLES*/ );
	#endif
	sceDisplayWaitVblankStart();
}
#endif /* (1==USE_PSPAUDIOLIB) */
/*	 */
#if (0==USE_PSPAUDIOLIB)
static void ns86_sound_update(int p)
{
	INT16 *buffer = (INT16 *)p;
	#if 0
	/*(pmame04r/src/psp_sound/sound_namcos86.c̃Rsy)*/
	INT16 mixing_buffer[PSP_SOUND_SAMPLES*2];
	/* ɂ44100 ͖pł͂Ȃ */
	//if (SND_44100==(sr))
	{
		X68000_Update_stream(mixing_buffer, PSP_SOUND_SAMPLES);
	int i;
		for (i = 0; i < PSP_SOUND_SAMPLES; i++)
		{
			*buffer++ = mixing_buffer[i];
		}
	}
	#else
	X68000_Update_stream( (INT16 *)p, PSP_SOUND_SAMPLES);
	/*ʉƂ̃~LVÓȀꏊł̂Ǝv*/
	/*Xbh₵ĕĂoƎvPhȎ͂Ȃǂ*/
	/* psp̃XybN̓XeIPCMWgbN炵 */
	#endif
}
#endif /* (0==USE_PSPAUDIOLIB) */

//============================================================
//	C
//============================================================

#ifdef KERNEL_MODE
static int user_main(SceSize args, void *argp)
#else
int main(int argc, char *argv[])
#endif //KERNEL_MODE
{
//	int res = 0;
	#if (0)
	char *_argv[5];
	int _argc = 0;
	#endif /* (0) */

	psp_loop = 1;
	psp_sleep = 0;

	#if (1==USE_DEBUG_MESSAGE)
	pspDebugScreenInit();
	#endif /* (1==USE_DEBUG_MESSAGE) */
	SetupCallbacks();

	// Setup Pad
	SceCtrlData pad;
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
//
	{
	int aa_samprate;
	aa_samprate = 44100/*cww_samprate*/;/* now 44100 only */

	/* MXDRVN */
	/*mxwin_LoadMXDRV*/mxwin_MXDRV_init(aa_samprate);
	}

	sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/TF2_00.MDX");
//	sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/GF3S.MDX");
//	sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/GR_B01.MDX");
	mxwin_PlayMDX( mdxfilename );
//
//
	#if (1==USE_PSPAUDIOLIB)
	pspAudioInit();
	pspAudioSetChannelCallback(0, audioCallback, NULL);
	#endif /* (1==USE_PSPAUDIOLIB) */
//
	#if (0==USE_PSPAUDIOLIB)
	psp_sound_init();

	psp_sound->stack	= 0x10000;				/* audio stack size[bytes] */
	psp_sound->stereo	= 1;					/* 0:monoral 1:stereo (This sample was stereo only) */
	psp_sound->callback = ns86_sound_update;	/* do audio callbacked function */

	psp_sound_start();
	psp_sound_enable(1);						/* psp_sound_enable(1) need after psp_sound_init() and psp_sound_start() */
	#endif /* (0==USE_PSPAUDIOLIB) */
//
	#if (1==USE_DEBUG_MESSAGE)
	pspDebugScreenSetXY(0,3);
	pspDebugScreenPrintf(
		"MDX play test A00(version alpha 0.00)\n"
		"Press X to end\n"
		"from psp-kaihatsu yotien.\n"
		"http://psp.nukenin.jp/" "\n"
	);
	#endif /* (1==USE_DEBUG_MESSAGE) */

//	scePowerSetClockFrequency(333, 333, 166);
	while (psp_loop)
	{
		sceCtrlPeekBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_SQUARE)
		{
			mxwin_MXDRV_Call( MXDRV_CALL05_STOP );/*mxwin_MXDRV_Stop();*/
			sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/TF2_00.MDX");
			mxwin_PlayMDX( mdxfilename );
		}
		else
		if (pad.Buttons & PSP_CTRL_TRIANGLE)
		{
			mxwin_MXDRV_Call( MXDRV_CALL05_STOP );/*mxwin_MXDRV_Stop();*/
			sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/GF3S.MDX");
			mxwin_PlayMDX( mdxfilename );
		}
		else
		if (pad.Buttons & PSP_CTRL_CIRCLE)
		{
			mxwin_MXDRV_Call( MXDRV_CALL05_STOP );/*mxwin_MXDRV_Stop();*/
			sprintf(mdxfilename, "ms0:/PSP/GAME/mdx_player/GR_B01.MDX");
			mxwin_PlayMDX( mdxfilename );
		}
		else
		if (pad.Buttons & PSP_CTRL_CROSS)
		{
			psp_loop = 0;
		}
//		sceDisplayWaitVblankStart();
	}
//	scePowerSetClockFrequency(222, 222, 111);
//
	#if (0==USE_PSPAUDIOLIB)
	psp_sound_enable(0);
	psp_sound_stop();
	#endif /* (0==USE_PSPAUDIOLIB) */

	/* I */
	mxwin_MXDRV_Call( MXDRV_CALL05_STOP );/*mxwin_MXDRV_Stop();*/
	mxwin_MXDRV_exit();
	#ifndef KERNEL_MODE
	sceKernelExitGame();/* need user mode only. [U[[ĥݎgp */
	#endif /* !defined(KERNEL_MODE) */
	return 0;
}
