
#include "osd_driver.h"

// /*static*/	volatile unsigned int ym2151_pcm_buf_pointer;
//============================================================
//
//	psp_sound.c - PSP sound functions
//
//============================================================

//#include "driver.h"
//#include "psp_main.h"
//#include "pg.h"
//#include "syscall.h"


//============================================================
//	LOCAL VARIABLES
//============================================================

static volatile int sound_active;
static int sound_handle;
static SceUID/*int*/ sound_thread;
static /*unsigned char*/int sound_enable/*sound_disable*/;


//#define MAXVOLUME 0x8000

//static int sound_disable=1/*0*/;


//int pga_volume =0x8000;/* used from src\psp\sound.c */
//static unsigned char sound_disable;

#define PSP_DIRECT_STREAM	1


#if (1==PSP_DIRECT_STREAM)
static struct sound_t sound_info;

//============================================================
//	GLOBAL VARIABLES
//============================================================

struct sound_t *psp_sound = &sound_info;

static volatile int sound_volume;
static INT16 sound_buffer[2][PSP_SOUND_BUFFER_SIZE/*2048*/];
//static int psp_sound_flip = 0;

#endif // (1==PSP_DIRECT_STREAM)

//unsigned long osd_cycles(void);
//#define PGA_VOLUME (0xffff)


//#define sound_volume (0xffff)
//============================================================
//	psp_sound_thread
//============================================================

static int psp_sound_thread(SceSize/*int*/ args, void *argp)
{
	int flip = 0;
	vsync();
	while (sound_active)
	{
		if (psp_sleep)
		{
			do
			{
				sceKernelDelayThread(5000000);
			} while (psp_sleep);
		}

		if (sound_enable)//if (sound_disable)
		{
			(*psp_sound->callback)((int)sound_buffer[flip]);
			sceAudioOutputPannedBlocking(sound_handle, sound_volume, sound_volume, (char *)sound_buffer[flip]);
		}
		else
		{
			memset(sound_buffer[flip], 0, PSP_SOUND_BUFFER_SIZE);
			sceAudioOutputPannedBlocking(sound_handle, 0, 0, (char *)sound_buffer[flip]);
		}
		flip ^= 1;
	}
	return 0;
}


#if (1==PSP_DIRECT_STREAM)
//============================================================
//	psp_sound_set_volume
//============================================================

void psp_sound_set_volume(void)
{
	if (sound_active)
		sound_volume = PSP_AUDIO_VOLUME_MAX;
}

void psp_sound_add_volume(int val)
{
	sound_volume += val;
	if (sound_volume > PSP_AUDIO_VOLUME_MAX) {
		sound_volume = PSP_AUDIO_VOLUME_MAX;
	} else if (sound_volume < 0) {
		sound_volume = 0;
	}
}

#endif // (1==PSP_DIRECT_STREAM)
/*--------------------------------------------------------
	TEhL/؂ւ
--------------------------------------------------------*/

void psp_sound_enable(unsigned char set_to_enable)
{
	if (sound_active)
	{
		sound_enable = set_to_enable;//sound_disable = !enable;
		#if (1==PSP_DIRECT_STREAM)
		if (sound_enable) //if (!sound_disable)
			psp_sound_set_volume();
		else
			sound_volume = 0;
		#endif // (1==PSP_DIRECT_STREAM)
	}
}


//============================================================
//	psp_sound_init
//============================================================

//int psp_init_sound(void)
void psp_sound_init(void)
{
	#if (1==PSP_DIRECT_STREAM)
	sound_active  = 0;
	sound_thread  = -1;
	sound_handle  = -1;
	sound_volume  = 0;
	sound_enable  = 0;//sound_disable = 1;
	#endif // (1==PSP_DIRECT_STREAM)

//	stream_playing = 0;
//	stream_cache_data = 0;
//	stream_cache_len = 0;
//	stream_cache_stereo = 0;

	/* initialize SEAL audio library */
//	if ( soundcard == 0 || machine->sample_rate == 0 )
//	{
//		return 0;
//	}

//	psp_sound_start();//pgaInit();
//	pga_handle[0] =-1;

//	nominal_sample_rate = machine->sample_rate;
	//osd_set_mastervolume(attenuation);	/* set the startup volume */
//	return 0;
}


//============================================================
//	psp_sound_start
//============================================================

int psp_sound_start(void)//int pgaInit(void)
{
	sound_active  = 0;
	sound_thread  = -1;
	sound_handle  = -1;
	sound_enable  = 0;//sound_disable = 1;
	#if (1==PSP_DIRECT_STREAM)
	memset((void *)sound_buffer[0], 0, PSP_SOUND_BUFFER_SIZE);
	memset((void *)sound_buffer[1], 0, PSP_SOUND_BUFFER_SIZE);

	if (psp_sound->stereo)
		sound_handle = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL, PSP_SOUND_SAMPLES, PSP_AUDIO_FORMAT_STEREO);
	else
		sound_handle = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL, PSP_SOUND_SAMPLES, PSP_AUDIO_FORMAT_MONO);
	if (sound_handle < 0)
	{
		return 0;
	}

	sound_thread = sceKernelCreateThread("Sound thread", psp_sound_thread, 0x08, psp_sound->stack, 0, NULL);
	if (sound_thread < 0)
	{
		sceAudioChRelease(sound_handle);
		sound_handle = -1;
		return 0;
	}

	sound_active = 1;
	sceKernelStartThread(sound_thread, 0, 0);

	psp_sound_set_volume();

	return 1;
	#else // (0==PSP_DIRECT_STREAM)

	#endif // (PSP_DIRECT_STREAM)
}



//============================================================
//	psp_sound_stop
//============================================================

void psp_sound_stop(void)
{
	if (sound_thread >= 0)
	{
		#if (1==PSP_DIRECT_STREAM)
		sound_volume = 0;
		#endif // (1==PSP_DIRECT_STREAM)
		sound_enable = 0;//sound_disable = 1;

		sound_active = 0;
		sceKernelWaitThreadEnd(sound_thread, NULL);

		sceKernelDeleteThread(sound_thread);
		sound_thread = -1;

		sceAudioChRelease(sound_handle);
		sound_handle = -1;
	}
}


//============================================================
//	psp_sound_exit
//============================================================

//void psp_sound_exit(void)
//{
//	//if ( soundcard == 0 || machine->sample_rate == 0 ){		return;	}
//	//wavout_snd0_wavinfo =0x00;
//	psp_sound_stop();
//}


#if 0
//============================================================
//	psp_sound_set_priority
//============================================================

void psp_sound_set_priority(int priority)
{
	sceKernelChangeThreadPriority(sound_thread, priority);
}
#endif


//obt@64oCgEȂĂv݂
//[0]A[1]E
//Tvx44100
//vol1

